//+------------------------------------------------------------------+
//|                                           CF.mq4      |
//|                 Copyright  2016,    vm9999                      |
//|                                      vm9999@tut.by               |
//|  Thanks to Steve for his exiiting forum                          |
//|  Thanks to all who helped and inspired me                        |
//+------------------------------------------------------------------+
#property copyright "Copyright  2016,vm9999"
#property link      "vm9999@tut.by"

//----
#define        MAXORDERS            100
string pipFactor[]        = {"JPY","XAG","SILVER","BRENT","WTI","XAU","GOLD","SP500","S&P","UK100","WS30","DAX30","DJ30","NAS100","CAC400"};
double pipFactors[]       = { 100,  100,  100,     100,    100,  10,   10,    10,     10,   1,      1,     1,      1,    1,       1};
int factor;
string status="";
string mode="";
int ha;
double basket;
double openprice;
double signal;
double minutes=0;
double RSUP,RSDN;
int ARBUY=-1,ARSELL=-1,ARBUY1=-1,ARSELL1=-1;
double UPLEVEL,DOWNLEVEL;
double Color;
int totalbuy=0;
int totalsell=0;
int ordersinprofit=0;
double lasthigh;
double lastlow;
double CCIUP240,CCIDN240,CCISUP240,CCISDN240,CCIUP5,CCIDN5,CCISUP5,CCISDN5,CCIMA1,CCIENTRY1,CCIMA2401,CCIMA240,CCIENTRY2401,CCIENTRY240,CCITREND5,CCITREND240,CCITREND2401;
int zeroleveled=0;

int total=0;
bool   bUseStopLevelForTS = false;
bool   bUseTPLevelFor = True;
int    TrailingStop;
double UP,DN,UP1,DN1;

//extern string  TH = "<<< Trade Hours >>>";
int StartHour=0;
int EndHour=0;

int AR=0;
extern string BOX = "<<< Renko box size >>>";
extern int       BoxSize=500;
extern int       RenkoOSOBLevel=6;
extern string CCI = "<<< Double CCI periods >>>";
extern int TrendCCI_period = 140;
extern int EntryCCI_period = 60;
extern string MM = "<<< lot=0 for Money Management >>>";
extern double Lot = 0;
extern string LD = "<<< Lot size in percents of balance for MM>>>";
extern int risk = 10;
extern string  LM = "<<< Maximum of the orders in series. 0 for auto>>>";
extern int    MaxOrders      =  0;
//string BD = "<<< 1 if orders will open even if current trade in loss, 0 if after profit only>>>";
int   BothDirections=1;
extern string  PP = "<<< distance in pips between orders, 0 for every candle, -1 for auto >>>";
extern int Pipstep           = -1;
string  SS= "<<< Shashlik amount in pips, minimum pieces per skewer>>>";
int    shaslik;  
int    minpieces;
//extern string TS = "<<< Basket Trailing Stop>>>"
//int    BasketTrailingStop=-1;
//int    BasketPipstep=-1;
//int    TS.ATR.Factor=5;
extern string CP = "<<< Comission in pips for ECN to BE>>>";
extern int    AdditionalPips2BE=1;
extern string  LL = "<<< drawdown limit in percent of balance - close all in loss if reached >>>";
extern int ddlimit= 100;
//extern string RL = "<<< Recovery lot multiplier>>>";
//extern int Lmultiplier=2;
extern string RM = "<<< Recovery pips multiplier>>>";
extern int Pmultiplier=5;
extern string  ASE = "<<< Common settings >>>";
extern int    MagicNumber    = 0;
int pipstep;

double oldtrend;
double line;
double oldline;

int TakeProfit;


bool   PolLots        = false;

string  About = "<<< Instant Trade Analyzer >>>";

string  AnalyzerSetting = "<<< Analyzer Setting >>>";
bool    ChartSymbolOnly = true;
int     SpecificMagic = 0;

string  SkipCommentSetting = "<<< Skip Comment Setting >>>";
string  SkipComment_1 = "Deposit";
string  SkipComment_2 = "";
string  SkipComment_3 = "";
string  SkipComment_4 = "";
string  SkipComment_5 = "";

string EANAME = "  CrossFader";
string EAComment="";
string SkipComment[];
int SkipComments;

int DQ_ADJUST []  = { 0 , 0 , 1 , 10 , 1 , 10 , 100 };
int DQADJ, Ldig, DIGITS;


int prevtime;
double InitialSL;
double curprof;
bool exit,tickvalue,atrstop;

bool BuyOp=false;
bool SellOp=false;
double eRatio;

bool BUY=false;
bool SELL=false;
//bool CROSSING=false;




string  trend_signal = "", trend_main = "", trend_level = "";
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
      //----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   
   tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   DIGITS = MarketInfo(Symbol(),MODE_DIGITS);
   DQADJ = DQ_ADJUST [ DIGITS ];

   Ldig = 2;
   if(MarketInfo(Symbol(),MODE_MINLOT) > 0.07) Ldig = 1;
   if(MarketInfo(Symbol(),MODE_MINLOT) > 0.7) Ldig = 0;

   int i=0;
   if(SkipComment_1 != "") { SkipComment[i] = SkipComment_1; i++; }
   if(SkipComment_2 != "") { SkipComment[i] = SkipComment_2; i++; }
   if(SkipComment_3 != "") { SkipComment[i] = SkipComment_3; i++; }
   if(SkipComment_4 != "") { SkipComment[i] = SkipComment_4; i++; }
   if(SkipComment_5 != "") { SkipComment[i] = SkipComment_5; i++; }

   SkipComments = i;

   Trade_Analyzer();
   GlobalVariablesDeleteAll();
   
  // if (BasketTrailingStop>0) BasketTrailingStop*=factor;//magft
  // if (BasketPipstep>0) BasketPipstep*=factor;//magft
  // if (AdditionalPips2BE>0) AdditionalPips2BE*=factor;//magft
   if (pipstep>0) pipstep*=factor;//magft
   
	factor = PFactor(Symbol());
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   //----
 //  if(!IsTesting())
   {
      CheckTradeContext();
      Trade_Analyzer();
   }
   

   
   double lot=0;
   int i=0;
   total=0;
   double TotalLots=0; 
   
   
double CashProfit=0;//opened profit in currency //magft
double curprofit=0;//opened profit in pips
double lastprofit=0;


  


//Calculation for nubmer of orders and open profit in pips
   for(i=0;i<OrdersTotal();i++)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if (OrderSymbol()!=Symbol()) continue;
      if (OrderSymbol()==Symbol())
      {
         //if(InitialSL!=OrderStopLoss())
         //   OrderModify(OrderTicket(),OrderOpenPrice(),InitialSL,0,0,Orange);
         
         TotalLots=TotalLots+OrderLots();
         CashProfit+=(OrderProfit( )+OrderSwap( )+OrderCommission( ));//magft
         curprofit += CalculateTradeProfitInPips ( OrderType() );//magft
         if(OrderProfit()>0) ordersinprofit++;
         if(OrderProfit()<0) ordersinprofit--;
         openprice=OrderOpenPrice();
         lastprofit=OrderProfit();
         total++;
         
      }
   }
   //curprofit*=factor;//converts from pips to points magft
   
 
//Shashlik under umbrella
int umbrella=0; 
int pillar=0; 
double umbrellaprofit=0; 
double pillarprofit=0; 
double profit;
       
for(i=0;i<OrdersTotal();i++)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if (OrderSymbol()!=Symbol()) continue;
      if (OrderSymbol()==Symbol())
      {
            
         if ( OrderType() == OP_BUY )
            profit = (Bid - OrderOpenPrice()) * factor;
         if ( OrderType() == OP_SELL )
            profit = (OrderOpenPrice() - Ask) * factor;      
         if(profit>umbrellaprofit)
          {
            umbrellaprofit=profit;
            umbrella=OrderTicket(); 
          } 
    
      }
   }  
   
   
//roast shashlik (shish kebab)         
if(total>1 && umbrellaprofit>0 && (curprofit-umbrellaprofit) > shaslik) {closeOrders(OP_BUY,umbrella,1);closeOrders(OP_SELL,umbrella,1);}
status="";

 // Continue trading after reboot of the expert
 if (total>0)
 {
    for(i=0;i<OrdersTotal();i++)
    {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderType()==OP_BUY && OrderSymbol()==Symbol())  {BuyOp=true;status="BUY trades found. Will continue and manage.";}
       if (OrderType()==OP_SELL && OrderSymbol()==Symbol()) {SellOp=true;status="SELL trades found. Will continue and manage.";}
     }  
 }       
 
//double RUP,RDN;
//!IsTesting() || 
//if(!IsTesting() || Time[0] != prevtime) 
{
  int history;
  if(IsTesting()) history=8000;
  else history=10000;
 
    
      
   UP=iCustom(NULL,240,"AdaptiveRenko",1,1,7,0,10,history,2,0);
   DN=iCustom(NULL,240,"AdaptiveRenko",1,1,7,0,10,history,3,0);
//   UP1=iCustom(NULL,0,"AdaptiveRenko",1,1,7,0,10,history,2,1);
//DN1=iCustom(NULL,0,"AdaptiveRenko",1,1,7,0,10,history,3,1);
     
   //if(UP>UP1) {ARBUY=1;ARSELL=0;}
   //if(DN<DN1) {ARSELL=1;ARBUY=0;}
   
   int XOUP=iCustom(NULL,240,"TSVRenkoFX",BoxSize,0,1);
   int XODOWN=iCustom(NULL,240,"TSVRenkoFX",BoxSize,1,1);
   //int XOUP1=iCustom(NULL,0,"TSV  RenkoFX",BoxSize,0,1);
   //int XODOWN1=iCustom(NULL,0,"TSV  RenkoFX",BoxSize,1,1);
   
   
   CCIUP240=iCustom(NULL,240,"DoubleCCI-With_SMA",TrendCCI_period,EntryCCI_period,0,1);
   CCIDN240=iCustom(NULL,240,"DoubleCCI-With_SMA",TrendCCI_period,EntryCCI_period,1,1);
   CCISUP240=iCustom(NULL,240,"DoubleCCI-With_SMA",TrendCCI_period,EntryCCI_period,2,1);
   CCISDN240=iCustom(NULL,240,"DoubleCCI-With_SMA",TrendCCI_period,EntryCCI_period,3,1);
   CCIMA240=iCustom(NULL,240,"DoubleCCI-With_SMA",TrendCCI_period,EntryCCI_period,5,1); 
   CCIENTRY240=iCustom(NULL,240,"DoubleCCI-With_SMA",TrendCCI_period,EntryCCI_period,6,1); 
   CCITREND240=iCustom(NULL,240,"DoubleCCI-With_SMA",TrendCCI_period,EntryCCI_period,4,1);
 
   
   
}

   
//if(total==0){}
    // Open orders
   if(StartHour==EndHour || (EndHour>StartHour && TimeHour(TimeCurrent()) >StartHour && TimeHour(TimeCurrent()) <EndHour) || (EndHour<StartHour && (TimeHour(TimeCurrent()) >StartHour) || TimeHour(TimeCurrent()) <EndHour))
   {
   
     if(XOUP>1    && CCISUP240>0)   {BUY=true;SELL=false;}
     if(XODOWN<-1 && CCISDN240<0)   {SELL=true;BUY=false;}
    // if(XOUP>0   && CCIENTRY240>CCIMA240 )      {BUY=true;SELL=false;}
    // if(XODOWN<0 && CCIENTRY240<CCIMA240)   {SELL=true;BUY=false;}
   
   }         
    else status=status+" Trade disabled by working time settings.";
   //  && curprofit>=0
   /*
   if(AccountEquity()>AccountBalance()*1.3)
   {
     closeOrders(OP_BUY,0); BUY=; BuyOp=0; 
     closeOrders(OP_SELL,0);SELL=0;SellOp=0;
   }
   */
   if(BuyOp  && XOUP>RenkoOSOBLevel)    {BUY=false; BuyOp=false;}
   if(SellOp && XODOWN<-RenkoOSOBLevel) {SELL=false; SellOp=false;}
   
   //Closing series
   if(SellOp && CCIDN240<0 && (curprofit-umbrellaprofit)>=0) {closeOrders(OP_SELL,0,0);SELL=false;SellOp=false;}  
   if(BuyOp  && CCIUP240>0 && (curprofit-umbrellaprofit)>=0) {closeOrders(OP_BUY,0,0); BUY=false; BuyOp=false;}
   //Closing umbrella
 //  if(SellOp && XOUP>0 && curprofit>=0) {closeOrders(OP_SELL,0,0);SELL=false;SellOp=false;}  
 //  if(BuyOp  && XODOWN<0 && curprofit>=0) {closeOrders(OP_BUY,0,0); BUY=false; BuyOp=false;}
         
int ATR=(UP-DN)* factor;    
int spread  = (Ask - Bid) * factor;
double basketprofit;
if (Pipstep==-1)
{
     pipstep=ATR/3+spread;
     Pipstep=pipstep;  
}

shaslik=ATR/2;  
minpieces=1;

//if(umbrellaprofit>3*pipstep && total>0 && zeroleveled!=total) ZeroLevel();


if(lastprofit<0) {pipstep=ATR;status=status+ATR+" pipstep set.";}
if(lastprofit>0) {lot=Lot;pipstep=Pipstep;status=status+" REGULAR pipstep set.";}
if(umbrellaprofit>0) {lot=Lot;pipstep=Pipstep;status=status+" REGULAR pipstep set.";}
   
//Lots and maxorders calculation
if (Lot==0)
{
   lot = NormalizeDouble(risk*AccountEquity()/100000,2);
   lot=NormalizeLots(Symbol(),lot); 
   status=status+" Lot autocalculated.";
}
   else
{
      lot=Lot; 
      status=status+" Lot user defined.";
}
 if(lot==0) lot=MarketInfo(Symbol(),MODE_MINLOT);   
 /*
 if(total==0) lot=lot*5;
 if(total==1) lot=lot*4;
 if(total==2) lot=lot*3;
 if(total==3) lot=lot*2;
*/ 
 //if(total>3)  lot=Lot;
 
    
if (MaxOrders==0)  
    MaxOrders      =  AccountEquity()/MarketInfo(Symbol(),MODE_MINLOT)/2000;

if (MaxOrders<3)
   {  
      MaxOrders      = 5; // we need minimum 5 orders for EA 
      
   }      
   
  EAComment="\n"+                       
            "  XOUP        :"+XOUP+" "+ "                   XODN:"+XODOWN+"\n"+
            "  UP            :"+UP+" "+"     DN:"+DN+"\n"+
            "  ---------UMBRELLA--------------\n"+    
            
            "  UMBRELLA PROFIT :"+DoubleToStr(umbrellaprofit,2)+"\n"+ /*magft*/
            "  CURPROFIT           :"+DoubleToStr(curprofit,0)+"\n"+  /*magft*/
                        
            "  ---------------PIPSTEP-----\n"+    
            "  FACTOR               :"+factor+"\n"+
            "  ATR                      :"+ATR+"\n"+
            "  ORDERS PIPSTEP  :"+pipstep+"\n"+  
            "  OPENPRICE           :"+DoubleToStr(openprice,Digits)+"\n"+  
            "  BUY PIPSTEP         :"+DoubleToStr((Ask-openprice)* factor,0)+"\n"+  /*magft*/
            "  SELL PIPSTEP         :"+DoubleToStr((openprice-Bid)* factor,0)+"\n"+  /*magft*/
            "  ---------------TRADE------\n"+
            "  BUY                       :"+BUY+"\n"+ 
            "  SELL                       :"+SELL+"\n"+ 
            "  SellOp                    :"+SellOp+"\n"+ 
            "  BuyOp                   :"+BuyOp+"\n"+ 
            "  PROFIT SELL          :"+DoubleToStr(OpenProfit(OP_SELL),2)+"\n"+ /*magft*/
            "  PROFIT BUY          :"+DoubleToStr(OpenProfit(OP_BUY),2)+"\n"+ /*magft*/
            "  -----MONEY MANAGEMENT ---\n"+
            "  LOT SIZE                :"+DoubleToStr(NormalizeDouble(lot,2),2)+"\n"+
            "  MAX ORDERS         :"+DoubleToStr(NormalizeDouble(MaxOrders,0),0)+"\n"+
            "  OPENED ORDERS   :"+total+"\n";
            
                 
            
              
            

  
//Account protection
if(AccountEquity()< (AccountBalance()-ddlimit*AccountBalance()/100))

             {closeOrders(OP_SELL,0,0);closeOrders(OP_BUY,0,0);BUY=0;BuyOp=0;SELL=0;SellOp=0; }


if (total==0)
{
 zeroleveled=0;
 if (BUY)
 {
      SellOp=False;
      BuyOp=true;
 }
 
  if (SELL)
  {
      SellOp=true;
      BuyOp=false;

 }
} 
 

  
   //if(Time[0] == prevtime) 
 //      return(0);
   
   if(Time[0] != prevtime) 
     prevtime = Time[0];
   if(!IsTradeAllowed()) 
     {
       prevtime = Time[1];
       return(0);
     }
   //if(Volume[0]>1) return;  
   
    
   
  if (total < MaxOrders || MaxOrders == 0)
     {   
     if (total==0) openprice=Bid;
       if(( (BuyOp && total==0) || (BothDirections==0 && BuyOp && total>0 && (Ask-openprice)* factor>pipstep)  || (BothDirections==1 && BuyOp && total>0 && MathAbs(Ask-openprice)* factor>pipstep)))
        { 
             openprice=Ask;
                 if (InitialSL!=0)
          {
          
              //OrderSend(Symbol(),OP_BUY,lot,NormalizeDouble(Ask,Digits),3,NormalizeDouble(Bid-(InitialSL*Point),Digits),NormalizeDouble(Bid+TakeProfit*Point,Digits),"",MagicNumber,0,Green);
                OrderSend(Symbol(),OP_BUY,lot,NormalizeDouble(Ask,Digits),3,InitialSL,0,"",MagicNumber,0,Green);
              //alert=0;
          }
         else
          {
         
              OrderSend(Symbol(),OP_BUY,lot,NormalizeDouble(Ask,Digits),3,0,0,"",MagicNumber,0,Green);
             // alert=0;
          }
        }
       if(((SellOp && total==0) || (BothDirections==0 && SellOp && total>0 && (openprice-Bid)* factor>pipstep)) || (BothDirections==1 && SellOp && total>0 && (MathAbs(openprice-Bid)* factor>pipstep)))
        {
         if (total==0) openprice=Ask; 
         if (InitialSL!=0)
          {
         
                //OrderSend(Symbol(),OP_SELL,lot,NormalizeDouble(Bid,Digits),3,NormalizeDouble(Ask+(InitialSL*Point),Digits),NormalizeDouble(Ask-TakeProfit*Point,Digits),"",MagicNumber,0,Red);
                  OrderSend(Symbol(),OP_SELL,lot,NormalizeDouble(Bid,Digits),3,InitialSL,0,"",MagicNumber,0,Red);
                //alert=0;
          } 
         else 
          {
         
                OrderSend(Symbol(),OP_SELL,lot,NormalizeDouble(Bid,Digits),3,0,0,"",MagicNumber,0,Red);
              //  alert=0;
          }
        }
      }
//----
   return(0);
 
}

void CheckTradeContext()
{
   if(!IsTradeAllowed())
      {
//        Print("Trade context is busy! Wait until it is free...");
        // infinite loop
        while(true)
          {
            // if the expert was stopped by the user, stop operation
            if(IsStopped()) 
              { 
//                Print("The expert was stopped by the user!"); 
                return(-1); 
              }
            // if trade context has become free, terminate the loop and start trading
            if(IsTradeAllowed())
              {
//                Print("Trade context has become free!");
                break;
              }
            // if no loop breaking condition has been met, "wait" for 0.1 sec
            // and restart checking
            Sleep(100);
          }
      }
}    
//+------------------------------------------------------------------+
//| Trade Analyzer
//+------------------------------------------------------------------+
void Trade_Analyzer()
{
   

      Comment(EAComment);
      return(0);

          
}  


int closeOrders(int type, int umbrella, int profitonly)
  {
//----
   
   int total=OrdersTotal();  
   int ordertype;
   if (total==0) {Print("Nothing to close");return;}
   int ticket; 
   double priceClose;
   for(int i=total-1;i>=0;i--)
      {
      if (OrderSelect(i,SELECT_BY_POS))
         {
         ordertype=OrderType();
         if(type!=ordertype) continue;
         if(OrderSymbol()!=Symbol()) continue;
         ticket=OrderTicket();
         if(ticket==umbrella) continue;
         if(profitonly==1 && OrderProfit()<0) continue;
         switch(ordertype)
            {
            case 0:
       
               priceClose=NormalizeDouble(MarketInfo(OrderSymbol(),MODE_BID),Digits);
               Print("Closing order  ",i," ",ticket);
               OrderClose(ticket,OrderLots(),priceClose,3,Red);
               break;
            case 1:
                priceClose=NormalizeDouble(MarketInfo(OrderSymbol(),MODE_ASK),Digits);
               Print("Closing order  ",i," ",ticket);
               OrderClose(ticket,OrderLots(),priceClose,3,Red);
               break;
            default:
               Print("Delete order  ",i," ",ticket);
               OrderDelete(ticket);  
               break;
            }    
         }
         
      }   
//----
   return(0);
  } 
  
  

int ZeroLevel()
  {
   int kol=0;
   int kolOK=0;
   int i=0;
   double lots=0;
   double sum=0;
   double sum1=0;
   for (i=0; i<OrdersTotal(); i++)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if (OrderSymbol()!=Symbol()) continue;
      if (OrderType()==OP_BUY)
      {
       lots=lots+OrderLots();
       sum=sum+OrderLots()*OrderOpenPrice();
       sum1=sum1+OrderProfit( )+OrderSwap( )+OrderCommission( )-(AdditionalPips2BE*OrderLots()/MarketInfo(Symbol(),MODE_MINLOT)* factor); 
       kol=kol+1;
      }
      if (OrderType()==OP_SELL)
      {
       lots=lots-OrderLots();
       sum=sum-OrderLots()*OrderOpenPrice();
       sum1=sum1+OrderProfit( )+OrderSwap( )+OrderCommission( )-(AdditionalPips2BE*OrderLots()/MarketInfo(Symbol(),MODE_MINLOT)* factor); 
       kol=kol+1;
      }
   }
   double zeroprice=0;
   if (lots!=0) zeroprice=sum/lots;
   zeroprice = (MathRound(zeroprice*MathPow(10,Digits)))/MathPow(10,Digits);

   
//-----

 int res = 0;
 for (i=0; i<OrdersTotal(); i++)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if (OrderSymbol()!=Symbol()) continue;
        
         if (zeroprice>Ask) 
         { if (OrderType()==OP_BUY) {if (zeroprice == OrderTakeProfit()) res=res+1; else { if (OrderModify(OrderTicket(),0,OrderStopLoss(),zeroprice,0,CLR_NONE)) res = res+1;}    }
           if (OrderType()==OP_SELL){if (zeroprice == OrderStopLoss()) res=res+1; else { if (  OrderModify(OrderTicket(),0,zeroprice,OrderTakeProfit(),0,CLR_NONE)) res = res+1;}     } }
         if (zeroprice<Bid) 
         { if (OrderType()==OP_BUY) {if (zeroprice == OrderStopLoss()) res=res+1; else { if (  OrderModify(OrderTicket(),0,zeroprice,OrderTakeProfit(),0,CLR_NONE)) res = res+1;} }
           if (OrderType()==OP_SELL){if (zeroprice == OrderTakeProfit()) res=res+1; else { if (OrderModify(OrderTicket(),0,OrderStopLoss(),zeroprice,0,CLR_NONE)) res = res+1;}    } } 
          
   }

 zeroleveled=res;
 /*
 if (kol==res) 
 {
  // Alert ("All orders were changed! Break-even point is exposed. !");
   zeroleveled=total;

 }  
 else zeroleveled=res;
   
//    else Alert ("!!! Attention! Unable to change - " +(kol-res)+ " order(s) from "+kol+" we have");
*/
 
//------

   return(0);
  }

//magft  
//+--------------------------------------------------------------------------------------+
double CalculateTradeProfitInPips ( int type )
{
   //Returns the pips OVERSOLDl of the currently selected trade. Called by CountOpenTrades()
   double profit;
   // double point = BrokerPoint(OrderSymbol() ); // no real use
   double ask = MarketInfo ( OrderSymbol(), MODE_ASK );
   double bid = MarketInfo ( OrderSymbol(), MODE_BID );

   if ( OrderType() == OP_BUY )
   {
      profit = bid - OrderOpenPrice();
   }//if (OrderType() == OP_BUY)

   if ( OrderType() == OP_SELL )
   {
      profit = OrderOpenPrice() - ask;
   }//if (OrderType() == OP_SELL)
   profit *= PFactor ( OrderSymbol() ); // use PFactor instead of point.

   return ( profit ); // in real pips
}//double CalculateTradeProfitInPips(int type)
/*
int PFactor ( string pair )
{
   int PipFactor = 10000; // correct factor for most pairs
   if ( StringFind ( pair, "JPY", 0 ) != -1 || StringFind ( pair, "XAG", 0 ) != -1 )
      PipFactor = 100; // if jpy or silver
   if ( StringFind ( pair, "XAU", 0 ) != -1 )
      PipFactor = 10; // if gold
   return ( PipFactor );
}//End int PFactor(string pair)
//+--------------------------------------------------------------------------------------+
*/
double OpenProfit(int OrdType)
{
   double Profit = 0.0;

   for(int i=0; i<OrdersTotal(); i++)
   {
      if( !OrderSelect(i, SELECT_BY_POS, MODE_TRADES) ) continue; // select check
      if( OrderType() != OrdType ) continue; // order type check
      if( OrderSymbol() != Symbol() ) continue; // order type check
      if( IsSkip( OrderSymbol(), OrderMagicNumber(), OrderComment(), OrderOpenTime(), OrderCloseTime()) ) continue;
      
      Profit += (OrderProfit()+OrderSwap()+OrderCommission());
   }

   return(Profit);
}
//+------------------------------------------------------------------+
//| IsSkip (bool)
//+------------------------------------------------------------------+
bool IsSkip(string ORDERSYMBOL, int ORDERMAGIC, string ORDERCOMMENT, datetime ORDEROPENTIME, datetime ORDERCLOSETIME)
{
   if(ChartSymbolOnly && Symbol() != ORDERSYMBOL) return(true); // symbol check
   if(SpecificMagic > 0 && ORDERMAGIC != SpecificMagic) return(true); // magic check
   if( IsSkipComment( ORDERCOMMENT ) ) return(true); // comment check
   

   return(false);
}  
//+------------------------------------------------------------------+
//| IsSkipComment (bool)
//+------------------------------------------------------------------+
bool IsSkipComment(string OrdComment)
{
   bool IsSkipComment = false;
   for(int i=0; i<SkipComments; i++) if(StringFind(OrdComment, SkipComment[i]) != -1) IsSkipComment = true;

   return(IsSkipComment);
}  

double PFactor(string symbol)
{
   for (int i = ArraySize(pipFactor)-1; i >=0; i-- ) 
      if (StringFind(symbol,pipFactor[i],0) != -1) 
         return (pipFactors[i]);
   return(10000);
}

  //+------------------------------------------------------------------+
  double NormalizeLots(string _symbol, double lots)
  //+------------------------------------------------------------------+
  {
    lots = MathCeil(lots / MarketInfo(_symbol, MODE_LOTSTEP)) * MarketInfo(_symbol, MODE_LOTSTEP);
    lots = MathMax(lots,MarketInfo(_symbol, MODE_MINLOT));
    lots = MathMin(lots,MarketInfo(_symbol, MODE_MAXLOT));
    return (lots);  
  }

